From e509dcf9d003c5530916089226f5cf133dd58193 Mon Sep 17 00:00:00 2001
From: Pavel Baturko <pabftk@gmail.com>
Date: Sun, 20 Jan 2013 22:05:37 +0000
Subject: [PATCH] Decode UCS2 SMS to UTF8

---
 src/host/layer23/src/mobile/gsm411_sms.c |   13 ++++++++++++-
 1 files changed, 12 insertions(+), 1 deletions(-)

diff --git a/src/host/layer23/src/mobile/gsm411_sms.c b/src/host/layer23/src/mobile/gsm411_sms.c
index 9de1259..baa0989 100644
--- a/src/host/layer23/src/mobile/gsm411_sms.c
+++ b/src/host/layer23/src/mobile/gsm411_sms.c
@@ -38,6 +38,7 @@
 #include <osmocom/bb/mobile/transaction.h>
 #include <osmocom/bb/mobile/gsm411_sms.h>
 #include <osmocom/gsm/gsm0411_utils.h>
+#include <osmocom/gsm/gsm_utils.h>
 #include <osmocom/core/talloc.h>
 #include <osmocom/bb/mobile/vty.h>
 
@@ -225,6 +226,8 @@ static int gsm340_rx_tpdu(struct gsm_trans *trans, struct msgb *msg)
 	uint8_t *smsp = msgb_sms(msg);
 	struct gsm_sms *gsms;
 	unsigned int sms_alphabet;
+	uint8_t have_utf8_locale = 0;
+	char utf8_sms_text[256];
 	uint8_t sms_mti, sms_mms;
 	uint8_t oa_len_bytes;
 	uint8_t address_lv[12]; /* according to 03.40 / 9.1.2.5 */
@@ -285,7 +288,15 @@ static int gsm340_rx_tpdu(struct gsm_trans *trans, struct msgb *msg)
 			gsm_7bit_decode(gsms->text, smsp, gsms->user_data_len);
 			break;
 		case DCS_8BIT_DATA:
+			break;
 		case DCS_UCS2:
+			ucs2_to_utf8_decode(utf8_sms_text, sizeof(utf8_sms_text), gsms->user_data, gsms->user_data_len / 2);
+			have_utf8_locale = check_utf8_locale();
+			if (have_utf8_locale)
+				sprintf(gsms->text, "SMS was printed(decoded from UCS2 to UTF-8)");
+			else
+				sprintf(gsms->text, "SMS in UCS2. Was printed in hex(locale not UTF-8)");
+			break;
 		case DCS_NONE:
 			break;
 		}
@@ -298,7 +309,7 @@ static int gsm340_rx_tpdu(struct gsm_trans *trans, struct msgb *msg)
 	     gsms->protocol_id, gsms->data_coding_scheme, gsms->address,
 	     gsms->user_data_len,
 			sms_alphabet == DCS_7BIT_DEFAULT ? gsms->text :
-				osmo_hexdump(gsms->user_data,
+				(have_utf8_locale && sms_alphabet == DCS_UCS2) ? utf8_sms_text : osmo_hexdump(gsms->user_data,
 						gsms->user_data_len));
 
 	switch (sms_mti) {
-- 
1.7.2.5

